﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using Pixoneer.NXDL.NXVideo;

namespace XDL_VideoView1
{
public partial class Form1 : Form
{

XVideoIO m_VideoIO;         // Video입출력에 관한 객체를 생성. XVideoIO객체는 XVideo객체를 생성한다.
XVideo m_Video;             // XVideo객체는 실질적으로 비디오 스트리밍을 받아서 처리하는 객체이다. 
XVideoChannel m_channel;    // XVideoChannel은 보통 1개의 파일에는 1개의 스트리밍이 존재하지만, MPEG2TS와 같이 MultiChannel을 지원하는것도 존재한다.
                            // 결국 XVideoChannel이 스트리밍에 대한 파싱 및 도시를 위한 비디오 Frame 데이터 관리를 수행한다.

public Form1()
{
    InitializeComponent();
    m_VideoIO = new XVideoIO(); // VideoIO를 생성
}

private void openToolStripMenuItem_Click(object sender, EventArgs e)
{
    // 파일 Open을 수행한다.
    OpenFileDialog openFileDialog = new OpenFileDialog();
    openFileDialog.Filter = "TS file(*.ts)|*.ts||";
    openFileDialog.RestoreDirectory = true;

    if (openFileDialog.ShowDialog() != DialogResult.OK) return;

    // XVideoIO객체로터 XVideo객체를 생성한다.
    string strError = null;
    m_Video = m_VideoIO.OpenFile(openFileDialog.FileName, "XFFMPDRIVER", out strError);

    if (m_Video == null)
    {
        MessageBox.Show(strError);
        return;
    }

    // XVideoView객체에 XVideo객체와 Multi Channel인 경우를 고려하여 XVideo객체 안의 Channel에 대한 인덱스를 설정한다. 
    int nIdxChannel = 0;
    nxVideoView1.SetVideoChannel(m_Video, nIdxChannel);


    // XVideo객체로부터 특정 인덱스에 해당하는 Channel을 꺼낸다.
    m_channel = m_Video.GetChannel(nIdxChannel);

    if (m_channel == null)
    {
        MessageBox.Show("Channel is not valid");
    }

    // Channel을 활성화 시키고 Play시킨다.
    m_channel.Activate();

}

private void Form1_FormClosing(object sender, FormClosingEventArgs e)
{
    // Video 종료시에 XVideoView와 XVideo와의 관계를 정리한다.
    nxVideoView1.ResetVideoChannel();
    if (m_Video != null)
        m_Video.Close();
}

private void playToolStripMenuItem_Click(object sender, EventArgs e)
{
    m_channel.Play();
}

private void pauseToolStripMenuItem_Click(object sender, EventArgs e)
{
    m_channel.Pause();
}

private void resumeToolStripMenuItem_Click(object sender, EventArgs e)
{
    m_channel.Resume();
}

private void stopToolStripMenuItem_Click(object sender, EventArgs e)
{
    m_channel.Stop();
}

}
}
